Extractions = Class:derive("Extractions")
Extractions.Settings = {
  markOnComplete = true, --Add map marker for completed task?
  MinNumTroops = 4, --Min # enemy troops at LZ
  MaxNumTroops = 8, --Max # enemy troops at LZ
  MinNumBTR = 0, --Min # enemy BTRs at LZ
  MaxNumBTR = 2, --Max # enemy BTRs at LZ
  MinNumTpz = 0, --Min # enemy Tpzs at LZ
  MaxNumTpz = 1, --Max # enemy Tpzs at LZ
}

Extractions.Settings.EnemyTroopSpawn = "Insurgent Solider 1-1"
Extractions.Settings.EnemyBTRSpawn = "Insurgent BTR-80 1-1"
Extractions.Settings.EnemyTPzSpawn = "Insurgent Enemy TPz 1-1"
Extractions.EX_Zones = {
  "Extract-1",
  "Extract-2",
  "Extract-3",
  "Extract-4",
  "Extract-5",
  "Extract-6",
  "Extract-7",
  "Extract-8",
  "Extract-9",
  "Extract-10",
  "Extract-11",
  "Extract-12",
  "Extract-13",
  "Extract-14",
  "Extract-15",
  "Extract-16",
  "Extract-17",
  "Extract-18",
  "Extract-19",
  "Extract-20",
  "Extract-21",
  "Extract-22",
  "Extract-23",
  "Extract-24",
  "Extract-25",
  "Extract-26",
  "Extract-27",
  "Extract-28",
  "Extract-29",
  "Extract-30",
  "Extract-31",
  "Extract-32",
  "Extract-33",
  "Extract-34",
  "Extract-35",
} --Extraction Zones

Extractions.EX_Zones_North = {
  "Extract-North-1",
  
  }

function Extractions:New(playerGroup,ExtractZonesTables)
  local PlayerGroup = playerGroup

  --check if already assigned a transport Assignment
  if Function.GetMooseClientStateData(PlayerGroup,"hasAssignment") == true then
    Function.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
    MESSAGE:New("You have already been assigned a Task. Please review your briefing from F10 Menu. Complete you current task before selecting a new one.",15):ToGroup(PlayerGroup)
  else
    if Function.tablelength(ExtractZonesTables) >= 1 and Function.tablelength(Settings.RadioFreqs) >= 1 then
      --lets set some vars
      local EnemyGroupSet = SET_GROUP:New()
      local RadioFreq = Function.GetFreq()
      local inExtraction_Zone = false
      local troopsPickedUp = false
      local troopsUnloaded = false
      local ExtractionCompleted = false --Is CSAR mission Completed?
      local inAirSpace = false --within FARP Hollywood Airspace
      local firstTakeoff = false
      local Task_ID = Function.RandomNumber()

      --moose client hasAssigment to true
      Function.SetMooseClientStateData(PlayerGroup,"hasAssignment", true)
      
      --select random extraction zone
      local zoneName = Function.randomchoice(ExtractZonesTables)
      local Zone = ZONE:New(zoneName)
      Function.removeTableEntry(ExtractZonesTables,zoneName)
      local SpawnVec3Point = POINT_VEC3:NewFromVec3( Zone:GetVec3() )
      local LZ_AirSpace = ZONE_RADIUS:New( "Extract_LZ_"..Function.RandomVariable(3), Zone:GetVec2(), 3704 )
      
     --Place Extraction Troops 
     local InfantryGroup = Extractions.AlliedSquadSpawn:SpawnFromVec2( Zone:GetVec2() )
     local numofTroops = InfantryGroup:CountInZone(Zone)
     local InfantryCargo = CARGO_GROUP:New( InfantryGroup, "Troop", "Troop"..Function.RandomVariable(3), 500 )    
     
     --pop smoke
     if Zone:GetCoordinate():IsDay() == true then
      --day do smoke
      local ExSmoke = SCHEDULER:New( nil,
        function()
          if PlayerGroup:IsCompletelyInZone(LZ_AirSpace) and inExtraction_Zone == false then
          inExtraction_Zone = true
          Function.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
          PlayerGroup:Message("I hear you near by, popping red smoke. Please hurry!",15)
            --pop Smoke
            Zone:SmokeZone(SMOKECOLOR.Red,1)
          end
        end, {}, 1,1,0,5400)
               
     else
     
      --night to flare
      local ExFlare = SCHEDULER:New( nil,
        function()
          if PlayerGroup:IsCompletelyInZone(LZ_AirSpace) and inExtraction_Zone == false then
          inExtraction_Zone = true
          Function.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
          PlayerGroup:Message("I hear you near by, popping red flare. Please hurry!",15)
            --pop flare
          SCHEDULER:New( nil,
            function()
              Zone:FlareZone(FLARECOLOR.Red,1)
            end, {},2,4,0,180)
          end
        end, {}, 1,1,0,5400)
      
     end
      
      --spawn enemy forces
      local ranNumofTroops = math.random(Extractions.Settings.MinNumTroops,Extractions.Settings.MaxNumTroops) --gen random number of troops math.random(3,5)
        for EnemyTroopCount = ranNumofTroops,1,-1
        do
          local group = Extractions.EnemyTroopSpawn:SpawnFromVec2( SpawnVec3Point:GetVec2() )  
          EnemyGroupSet:AddGroupsByName(group)
        end
        
     local ranNumofBTRs = math.random(Extractions.Settings.MinNumBTR,Extractions.Settings.MaxNumBTR) --gen random number of troops math.random(3,5)
      for EnemyBTRCount = ranNumofBTRs,1,-1
      do
        local group = Extractions.EnemyBTRSpawn:SpawnFromVec2( SpawnVec3Point:GetVec2() )
        EnemyGroupSet:AddGroupsByName(group)
      end
    local ranNumofTPzs = math.random(Extractions.Settings.MinNumTpz,Extractions.Settings.MaxNumTpz) --gen random number of troops math.random(3,5)
      for EnemyTPzCount = ranNumofTPzs,1,-1
      do
        local group = Extractions.EnemyTPzSpawn:SpawnFromVec2( SpawnVec3Point:GetVec2() )
        EnemyGroupSet:AddGroupsByName(group)
      end
      
      --Create Beacon
      local beaconID = Function.CreateBeacon(Zone,RadioFreq)
      
      --Set Briefing Menu
     --Set Briefing Menu
      local ranSquad = Function.randomchoice(Settings.Squads)
      local ranRank = Function.randomchoice(Settings.Ranks)
      local ranName = Function.randomchoice(Settings.Names)
      local Briefing = Extractions.GetBriefing(zoneName,ranSquad,ranRank,ranName)
      
      local brief = "Mission #: "..Task_ID.."\n"..
          "Pilot: "..PlayerGroup:GetPlayerName().."\n"..
          "Objective: Troop Extraction Operation\n"..
          "Number of Troops : "..numofTroops.."\n"..
          "______________________\n\n".. 
          "Mission : "..Briefing.."\n"..
          "______________________\n\n".. 
          "BRA: "..Function.GetBearingToZone(PlayerGroup:GetVec3(),Zone:GetVec3())..'\n'..
          "ADF : "..RadioFreq.." Mhz FM Homing\n\n"..
          "Use F10 Map to locate possible enemy SAM sites and other hot spots you may wish to avoid."
           
      Function.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
      MESSAGE:New(brief,35):ToGroup(PlayerGroup)
       
      local function showBriefing()
        Function.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
        MESSAGE:New(brief,35):ToGroup(PlayerGroup)
      end
      local BriefingMenu = MENU_GROUP:New( PlayerGroup, "Your Assignment" )
      local BriefingMenuCommand = MENU_GROUP_COMMAND:New( PlayerGroup, "Briefing", BriefingMenu, showBriefing , PlayerGroup )
      
       --CREATE Task in DB
      local lz_lat, lz_long = coord.LOtoLL(Zone:GetPointVec3())
      --LogStats:Extract_Create_Task(Task_ID,Function.GetMooseClientStateData(PlayerGroup,"ucid"),PlayerGroup:GetTypeName(),brief,numofTroops,lz_lat,lz_long)
  
     
     --EVENTS
      --Takeoff
      PlayerGroup:HandleEvent(EVENTS.Takeoff)
      function PlayerGroup:OnEventTakeoff(EventData)
        
      end--end EVENTS.Takeoff
    
      PlayerGroup:HandleEvent(EVENTS.Land)
      function PlayerGroup:OnEventLand(EventData)
        
        --check if picking up troops
        if PlayerGroup:IsCompletelyInZone(ZONE_RADIUS:New( "Extract_LZ_"..Function.RandomVariable(3), Zone:GetVec2(), 121 )) and troopsPickedUp == false then 
           SCHEDULER:New( nil,
            function()
               --load troops
                --InfantryCargo:Board(PlayerGroup,25)
                InfantryCargo:Board(PlayerGroup,25) 
                troopsPickedUp = true
               
                Function.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
                PlayerGroup:Message("= Troops now boarding =",5)
                Function.StopBeacon(beaconID,RadioFreq) 
                
                if Zone:GetCoordinate():IsDay() == true then
                  ExSmoke:Stop()
                else
                  ExFlare:Stop()
                end
                
                -- Aftering pickign up troop Remove any Enemy Units if still alive after x minutes
                SCHEDULER:New( nil,
                function()
                  Function.DestroyGroupSet(EnemyGroupSet)
                end, {},180)
                

            end, {}, 2)
        end
        
        --If Landing in Safe Zone and troop nounload then unload troopUnloaded=false
        if Function.CheckIfInSafeZone(PlayerGroup,Settings.Allied_LZs) == true and troopsPickedUp == true and troopsUnloaded == false then
           SCHEDULER:New( nil,
            function()
               --load troops
               --MESSAGE:New("Unload...",3):ToAll()
               --InfantryCargo:UnBoard(POINT_VEC2:NewFromVec2(ZONE:New(TroopHoldZoneName):GetRandomVec2()))
               InfantryCargo:UnBoard()
               troopsUnloaded = true
               
               function InfantryCargo:onafterUnBoarding(ToPointVec2,Event,From,To,NearRadius)
                  --MESSAGE:New("On After Unboard Fire...",3):ToAll()
                  
                  BriefingMenu:Remove()
                  Function.SetMooseClientStateData(PlayerGroup,"hasAssignment", false)
                  ExtractionCompleted = true
                  
                  --Task Successful
                  --LogStats:Extract_Completed_Task(Task_ID,1)
                  --LogStats.CreatePlayerDataFile(Function.GetMooseClientStateData(PlayerGroup,"ucid"))
                  
                  local missionMarkerText = "Mission ID: "..Task_ID.." - Extraction\n"..
                                        "Pilot: "..PlayerGroup:GetPlayerName().."\n"..
                                        numofTroops.." troops extracted from battle."

                  if Extractions.Settings.markOnComplete == true then                                        
                    Function.CreateMarker(Zone,missionMarkerText,true)
                  end                    
                  --Acknowledge
                  SCHEDULER:New( nil,
                    function()
                      Function.PlaySoundTAll("radioscratch.ogg")
                      MESSAGE:New("Mission Successful! "..ranRank.." "..ranName.." and "..ranSquad.." has been extracted from battle! Nice Work "..PlayerGroup:GetPlayerName().."!",16,"HQ"):ToAll()
                      
                      --remove transported troops
                      SCHEDULER:New( nil,
                        function()
                          InfantryCargo:Destroy()
                          end, {},30)
                      
                      --log exteaction
                      LogStats.UpdateTransportJsonFile(LogStats.GetMooseClientStateData(PlayerGroup,'ucid'),nil,nil,1,numofTroops)

                    end, {},4)

               end
               
            end, {}, 2)
        end
        
      end
      
      PlayerGroup:HandleEvent(EVENTS.PlayerLeaveUnit)
      function PlayerGroup:OnEventPlayerLeaveUnit(EventData)
        if troopsUnloaded == false then
          BriefingMenu:Remove()
        end
        Function.DestroyGroupSet(EnemyGroupSet)
        Function.SetMooseClientStateData(PlayerGroup,"hasAssignment", false)
        if InfantryCargo:IsAlive() ~= nil and InfantryCargo:IsAlive() == true then
          InfantryCargo:Destroy()
        end
        Function.StopBeacon(beaconID,RadioFreq)
        
        if ExtractionCompleted == false then
          --LogStats:Extract_Completed_Task(Task_ID,0)
          --LogStats.CreatePlayerDataFile(Function.GetMooseClientStateData(PlayerGroup,"ucid"))
        end
      end
      
      PlayerGroup:HandleEvent(EVENTS.Dead)
      function PlayerGroup:OnEventDead(EventData)
        if troopsUnloaded == false then
          BriefingMenu:Remove()
        end
        --Function.DestroyGroupSet(EnemyGroupSet)
        Function.SetMooseClientStateData(PlayerGroup,"hasAssignment", false)
        if InfantryCargo:IsAlive() ~= nil and InfantryCargo:IsAlive() == true then
          InfantryCargo:Destroy()
        end
        Function.StopBeacon(beaconID,RadioFreq)
        
        if ExtractionCompleted == false then
          --LogStats:Extract_Completed_Task(Task_ID,0)
          --LogStats.CreatePlayerDataFile(Function.GetMooseClientStateData(PlayerGroup,"ucid"))
        end
      end
      
      --Crash
      PlayerGroup:HandleEvent(EVENTS.Crash)
      function PlayerGroup:OnEventCrash(EventData)
        if troopsUnloaded == false then
          BriefingMenu:Remove()
        end
        Function.DestroyGroupSet(EnemyGroupSet)
        Function.SetMooseClientStateData(PlayerGroup,"hasAssignment", false)
        if InfantryCargo:IsAlive() ~= nil and InfantryCargo:IsAlive() == true then
          InfantryCargo:Destroy()
        end
        Function.StopBeacon(beaconID,RadioFreq)
        if ExtractionCompleted == false then
          --LogStats:Extract_Completed_Task(Task_ID,0)
          --LogStats.CreatePlayerDataFile(Function.GetMooseClientStateData(PlayerGroup,"ucid"))
        end
      end
      
      

    else
      --no avalible zones or radio freqs
      Function.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
      MESSAGE:New("Currently no Troop Extraction Assingments at this time, please try back later.",10):ToGroup(PlayerGroup)
    end--end if ln19
    
  end--end if ln15
  
end--end function


--Functions
function Extractions:Menu(playerGroup)
  local PlayerGroup = playerGroup
  local PlayerGroupName = PlayerGroup:GetName()
  --Setup Menu Option
  local function ShowInst()
      local inst = "++ Troop Extraction Instructions ++"
      Function.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
      MESSAGE:New(inst,10):ToGroup(PlayerGroup)
    end
    
  local function GetAssignmentNorth()
  Function.PlaySoundToGroup("beep1.ogg",PlayerGroup)
  MESSAGE:New(">> Incoming Troop Extraction Assigment for "..PlayerGroupName,5):ToGroup(PlayerGroup)
  SCHEDULER:New( nil,
    function()
      Function.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
      Extractions:New(PlayerGroup,Extractions.EX_Zones_North)
    end, {},6)
    
  end
    
  local function GetAssignment()
    Function.PlaySoundToGroup("beep1.ogg",PlayerGroup)
    MESSAGE:New(">> Incoming Troop Extraction Assigment for "..PlayerGroupName,5):ToGroup(PlayerGroup)
    SCHEDULER:New( nil,
      function()
        Function.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
        Extractions:New(PlayerGroup,Extractions.EX_Zones)
      end, {},6)
    
  end
  
  --if huey or mi8 only
  if PlayerGroup:GetTypeName() == "UH-1H" or PlayerGroup:GetTypeName() == "Mi-8MT" then
    if Function.CheckIfInZone(PlayerGroup,Settings.Allied_North_LZs) == true then
      --north
      local TroopInsertionMenu = MENU_GROUP:New( PlayerGroup, "Troop Transport" )
      --local TIInstrustions = MENU_GROUP_COMMAND:New( PlayerGroup, "Instructions", TroopInsertionMenu, ShowInst , PlayerGroup )--instr in CSAR class
      local GetTIAssignment = MENU_GROUP_COMMAND:New( PlayerGroup, "Troop Extractions", TroopInsertionMenu, GetAssignmentNorth , PlayerGroup )
  
    end
    if Function.CheckIfInZone(PlayerGroup,Settings.Allied_South_LZs) == true then
      --south
      local TroopInsertionMenu = MENU_GROUP:New( PlayerGroup, "Troop Transport" )
    --local TIInstrustions = MENU_GROUP_COMMAND:New( PlayerGroup, "Instructions", TroopInsertionMenu, ShowInst , PlayerGroup )--instr in CSAR class
    local GetTIAssignment = MENU_GROUP_COMMAND:New( PlayerGroup, "Troop Extractions", TroopInsertionMenu, GetAssignment , PlayerGroup )
  
    end
    
    end

end

Extractions.AlliedSquadSpawn = SPAWN:New('Troop Extraction Templates')
      :InitRandomizeTemplate( {"Troop Extraction x 4","Troop Extraction x 5","Troop Extraction x 6","Troop Extraction x 8"} ) 
      --:InitHeading(0,359)

Extractions.EnemyTroopSpawn = SPAWN:New(Extractions.Settings.EnemyTroopSpawn)
     --:InitRandomizeZones({Zone})
      --:InitLimit(4,4)
      :InitHeading(0,359)
      :InitRandomizePosition( true , 600, 500 )
      --:SpawnScheduled(0.5,0)

Extractions.EnemyBTRSpawn = SPAWN:New(Extractions.Settings.EnemyBTRSpawn)
      :InitHeading(0,359)
      :InitRandomizePosition( true , 1500, 1100 )

      
Extractions.EnemyTPzSpawn = SPAWN:New(Extractions.Settings.EnemyTPzSpawn)
      :InitHeading(0,359)
      :InitRandomizePosition( true , 1200, 1000 )
      
function Extractions.GetBriefing(ZoneName,ranSquad,ranRank,ranName)
  local briefing = ""
  
  briefing = ranRank.." "..ranName.." of " ..ranSquad.. " is requesting extraction. Get to there location at once and return them to the nearest allied FARP or Base."

  return briefing
end

