Function = {}

--Blades of Steel Welcome Message
function Function.welcome_message(group,delay)
  local pilotName = group:GetPlayerName()
  local blank = ""
  
  if delay == nil then 
    delay = 8
  end
  
  MESSAGE:New("loading...", delay - 2):ToGroup(group)
  
  SCHEDULER:New( nil,
  function()
    --do time stuff
    local Tnow=timer.getAbsTime()
    local mission_time=Tnow-timer.getTime0()
    local mission_time_seconds=mission_time%60
    local mission_time_minutes=mission_time/60
    local local_time=UTILS.SecondsToClock(Tnow)
    local MissionTimeSec = Settings.FullMissionTime - mission_time
  
    --Discord Info
    --Time
    local dbLocalTime = Function.SecondsToClock(Tnow)
    local dbMissionTimeLeft = Function.SecondsToClock(MissionTimeSec)
  
    local WelcomeMsg = 
          "Welcome ".. pilotName .. ", To Blades of Steel - Syria.\nBrought to you by The Fraternity.\n\n"..
          "SRS Radio: srs.Functionernitysim.com\n\n"..
          "View briefing for mission information and link to live map.\n"..
          "See F10 Menu for Current Mission Status, Your Stats, ect.\n\n"..
          "===================\n"..
          "[ Current Time     : "..dbLocalTime.." ]\n"..
          "[ Server Restart   : "..dbMissionTimeLeft.." ]\n"..
          "===================\n\n"..
          "For questions,comments,feedback visit our discord.\n"..
          "Have Fun!!\n"..
          "-Element"
          
    --Function.PlaySoundToGroup("FunctionernityIntro.ogg",group)
    MESSAGE:New(WelcomeMsg, 20,"",true):ToGroup(group)
    
  end, {},delay)

end

function Function.ClientInTable (tab, val)
  for index, value in ipairs(tab) do
    if value == val then
      return true
    end
  end

  return false
end

function Function.CountGroupSet(groupSet)
local count = 0
groupSet:ForEachGroup(function(group)
        if group:IsAlive() then
          count = count + 1
        end
      end)
      return count
end

function Function.CountUnitSet(unitSet)
local count = 0
unitSet:ForEachGroup(function(unit)
        if unit:IsAlive() then
          count = count + 1
        end
      end)
      return count
end

function Function.CountUnitsInGroup(group)
  if group:IsAlive() ~= nil then
    local count = 0
    local units = group:GetUnits()
    for key, unit in pairs(units) do
        count = count + 1
    end
    return count
  else
    return 0
  end
  
  
end

--play SoundFile to User Group
function Function.PlaySoundToGroup(soundfile,group)
  local PlayAudioFile = USERSOUND:New( soundfile )
  PlayAudioFile:ToGroup(group)
end

--Play SoundFile to Unit
function Function.PlaySoundToUnit(soundfile,unit)
  local PlayAudioFile = USERSOUND:New( soundfile )
  local group = unit:GetGroup()
  PlayAudioFile:ToGroup(group)
end

--play SoundFile to All Users
function Function.PlaySoundTAll(soundfile)
  local PlayToAll = USERSOUND:New( soundfile )
  PlayToAll:ToAll()
end

-- Select random item from table
function Function.randomchoice(t) --Selects a random item from a table
  local keys = {}
  for key, value in pairs(t) do
    keys[#keys+1] = key --Store keys in another table
  end
  index = keys[math.random(1, #keys)]
  return t[index]
end
function Function.sanitise( str )
    str = str:gsub('%W','')
    return str
end

function Function.tablefind(tab,el)
    for index, value in pairs(tab) do
        if value == el then
            return index
        end
    end
end

function Function.removeTableEntry(tabel,val)
  table.remove( tabel, Function.tablefind(tabel, val) )
end

--Count number of items within table
function Function.tablelength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

--Explode all units within a group
function Function.explode(group)
  local unitsList = group:GetUnits()
    for i, unit in ipairs(unitsList) do
      Function.explodeUnit(unit)
    end
end

function Function.DestroyGroup(group)--will destroy all units in a group
  local unitsList = group:GetUnits()
    for i, unit in ipairs(unitsList) do
      if unit ~= nil and unit:IsAlive() == true then
        unit:Destroy()
      end
    end
end

function Function.dumpTable(o)--print tables
   if type(o) == 'table' then
      local s = '{ '
      for k,v in pairs(o) do
         if type(k) ~= 'number' then k = '"'..k..'"' end
         s = s .. '['..k..'] = ' .. dump(v) .. ','
      end
      return s .. '} '
   else
      return tostring(o)
   end
end

function Function.SecondsFormat(seconds)
    local hours = math.floor(seconds/3600)
    local mins = math.floor(seconds/60)
    local secs = math.floor(seconds - hours*3600 - mins *60)
    --return hours..":"..mins..":"..secs
    MESSAGE:New(hours.."/"..mins.."/"..secs):ToAll()
    
    if seconds <= 60 then
      return secs.." secs ago"
    end
    
    if seconds > 60 and mins < 60 then
      return mins.." mins ago"
    end
    
    if seconds > 3600 and seconds < 86400 then
      --show hours
      return hours.." hrs ago"
    end
    
    if seconds > 86400 then
      --show days
      return math.floor(seconds/86400).." days ago"
    end
    
end


function Function.table_to_string(tbl)
    local result = ""
    for k, v in pairs(tbl) do
        -- Check the key type (ignore any numerical keys - assume its an array)
        if type(k) == "string" then
            result = result.."[\""..k.."\"]".."="
        end

        -- Check the value type
        if type(v) == "table" then
            result = result..table_to_string(v)
        elseif type(v) == "boolean" then
            result = result..tostring(v)
        else
            result = result..v.."\n"
        end
        result = result
    end
    -- Remove leading commas from the result
    if result ~= "" then
        result = result:sub(1, result:len()-1)
    end
    return result..""
end

function Function.SecondsToClock(seconds)
  local seconds = tonumber(seconds)

  if seconds <= 0 then
    return "00:00:00";
  else
    hours = string.format("%02.f", math.floor(seconds/3600));
    mins = string.format("%02.f", math.floor(seconds/60 - (hours*60)));
    secs = string.format("%02.f", math.floor(seconds - hours*3600 - mins *60));
    return hours..":"..mins..":"..secs
  end
end

function Function.DestroyGroupSet(groupSet)--Detroy (remove) every unit in group set
  groupSet:ForEachGroup(function(group)
  
  if group:IsAlive() ~= nil and group:IsAlive() == true then
    group:Destroy()
   end
  end)
end

--Explode all units in group set. Requires a SET Group
function Function.explodeGroupSet(groupSet)
  groupSet:ForEachGroup(function(group)
    if group:IsAlive() ~= nil and group:IsAlive() == true then
      Function.explode(group)
    end
  end)
  
end

--Explode Unit
function Function.explodeUnit(unit)
  local boom1pos = unit:GetPointVec2()
  local pos = POINT_VEC2:New( boom1pos:GetLat(), boom1pos:GetLon() )
  trigger.action.explosion(pos, 100)
end

--Explode Static
function Function.explodeStatic(static)
  local boom1pos = static:GetPointVec2()
  local pos = POINT_VEC2:New( boom1pos:GetLat(), boom1pos:GetLon() )
  trigger.action.explosion(pos, 100)
end

function Function.SetMooseClientStateData(PlayerGroup,SetData, Data)
  local unitName = Function.GetUnitFromPlayer(PlayerGroup:GetPlayerUnits())
  local Client = SET_CLIENT:New():AddClientsByName(unitName)
    Client:ForEachClient(
      function(MooseClient)
        MooseClient:SetState( MooseClient, SetData, Data )
      end
    )
  Client = nil
end

function Function.GetMooseClientStateData(PlayerGroup,StateData)
  local data = ""
  local unitName = Function.GetUnitFromPlayer(PlayerGroup:GetPlayerUnits())
  local Client = SET_CLIENT:New():AddClientsByName(unitName)
    Client:ForEachClient(
      function(MooseClient)
        --MESSAGE:New('Your UCID '..MooseClient:GetState( MooseClient, "UCID" ),10):ToClient(MooseClient)
        data = MooseClient:GetState( MooseClient, StateData )
      end
    )
  Client = nil
  return data
end
function Function.GetUnitFromPlayer(GetPlayerUnitsTable)
  local unitsTables = GetPlayerUnitsTable
  for UnitId, UnitData in pairs( unitsTables ) do
      local UnitAction = UnitData -- Wrapper.Unit#UNIT
      return UnitAction:Name()
    end
end
function Function.RandomVariable(length)
  local res = ""
  for i = 1, length do
    res = res .. string.char(math.random(97, 122))
  end
  return res
end

function Function.RandomNumber()
  return math.random(10000000, 65000000)
end

function Function.LeavingSafeZoneCheck(Unit)
  local warning = false
  local group = Unit:GetGroup()
  local checkSch = SCHEDULER:New( nil,
  function()
    if AmbushZone.CheckIfInSafeZone(Unit,Settings.Allied_Area_Table) == false and warning == false then
       warning = true
       Function.PlaySoundToUnit("radioscratch.ogg",Unit)
       MESSAGE:New(Unit:GetPlayerName()..", be advised you are now entering enemy territory.",15,"HQ"):ToGroup(group)
    end
  end, {}, 1,1,0,3600)

end

function Function.GetFreq()
  local randomFreq = Function.randomchoice(Settings.RadioFreqs)
  Function.removeTableEntry(Settings.RadioFreqs,randomFreq)
  return randomFreq
end

function Function.CreateBeacon(zone,radiofreq,ID)--return beacon id
  local beaconID
  if ID == nil then
     beaconID = zone:GetName().."_"..Function.RandomVariable(4)
  else
    beaconID = ID
  end
  local radioFreq = radiofreq
  local _newBeacon = {
      beaconID = beaconID,
      zone = zone,
      radioFreq = radioFreq,
    }
    
  --add beacon to tbl
  table.insert(Settings.Beacons, _newBeacon)
  BASE:E( "Beacon Created - ID: "..beaconID..", Freq: "..radiofreq.." Mhz, Zone: "..zone:GetName())
  
  --Update
  Function.RefreshBeacons()
  
  return beaconID
end

function Function.RefreshBeacons()--table of beacons
  local audio = "l10n/DEFAULT/".."beacon.ogg"
  --will reboardcast all beacons
  for _, beacon in pairs(Settings.Beacons) do
    local Frequency = beacon.radioFreq * 1000000 -- Conversion to Hz
    --MESSAGE:New("BroadCasting : [ ID - " .. beacon.beaconID .. " Freq - "..beacon.radioFreq .. " ZoneName - "..beacon.zone:GetName().." ]",5):ToAll()
    --trigger.action.stopRadioTransmission(beacon.beaconID)
    trigger.action.radioTransmission(audio, beacon.zone:GetVec3(), radio.modulation.FM, false,Frequency, 1000,beacon.beaconID)
  end

end

function Function.StopBeacon(beaconId,Freq)
  --remove beacon from table
  Function.removeTableEntry(Settings.Beacons,beaconId)
  table.insert (Settings.RadioFreqs, Freq)
  --stop beacon
  trigger.action.stopRadioTransmission(beaconId)
  BASE:E( "Beacon Stopped - ID: "..beaconId..", Freq: "..Freq.." Mhz")
  Function.RefreshBeacons()
end

function Function.BeaconScheduler()
    --MESSAGE:New("BeaconScheduler",5):ToAll()
    timer.scheduleFunction(Function.BeaconScheduler, nil, timer.getTime() + 5)
    Function.RefreshBeacons()
end

function Function.GetBearingToZone(groupPoint,zonePoint) 
  local group_1_pos = groupPoint
  local group_2_pos = zonePoint
  local distance = ((group_1_pos.x - group_2_pos.x)^2 + (group_1_pos.z - group_2_pos.z)^2)^0.5
  local bearing_vector = {
    x = group_2_pos.x - group_1_pos.x, 
    y = group_2_pos.y - group_1_pos.y, 
    z = group_2_pos.z - group_1_pos.z
    }
  local bearing_rad = math.atan2(bearing_vector.z, bearing_vector.x)
  if bearing_rad < 0 then
      bearing_rad = bearing_rad + (2 * math.pi) 
    end
    local bearing = math.deg(bearing_rad)
    return math.floor(bearing)..' Degrees for about '..math.floor(UTILS.MetersToNM(distance)).." Nm."
end

function Function.CreateMarker(unit,text,readOnly,expire)
  local coord = unit:GetCoordinate()
  if readOnly == nil or readOnly == false then
    readOnly = false
  end
    
  if expire == nil or expire == 0 then
    --never expire
    coord:MarkToAll(text,readOnly)
  else
    --add with timer
    local markID = coord:MarkToAll(text,readOnly)
    local markerScheduler = SCHEDULER:New( nil,
          function()
            coord:RemoveMark(markID)
          end, {},expire)
  end
    
end

function Function.AddMarkerTable(unit,missionID,text,ucid)
  --Settings.CurrentMissionMarkers
  local data = {}
  local PointVec3 = unit:GetPointVec3()
  local user_id = string.sub(ucid,1,8)
  local ID = missionID
  local markerText = text
  local lat, long = coord.LOtoLL(PointVec3)
  local LLString = UTILS.tostringLL( lat, long, 2, false )
  
  --add data
  data.id = ID
  data.ucid = user_id
  data.lat = lat
  data.long = long
  data.LLString = LLString
  data.markerText = markerText
  
  table.insert(Settings.CurrentMissionMarkers, data)
  
  --testing
  --TheFrat.AddMarkerTable(unit,markID,text,TheFrat.GetMooseClientStateData(PlayerGroup,"ucid"))
  
end

function Function.file_exists(name)
   local f=io.open(name,"r")
   if f~=nil then io.close(f) return true else return false end
end

function Function.CheckIfInZone(PlayerGroup,zoneTable)
  local result = false
  for i = 1, #zoneTable do
    --print(i, ". ", safeLandingZones[i])
      if PlayerGroup:IsCompletelyInZone(zoneTable[i]) then
        result = true
      end
  end
  return result
end

function Function.CheckIfInSafeZone(PlayerGroup,safeLandingZones)
  local result = false
  for i = 1, #safeLandingZones do
    --print(i, ". ", safeLandingZones[i])
      if PlayerGroup:IsCompletelyInZone(safeLandingZones[i]) then
        result = true
      end
  end
  return result
end

function Function.GetBRAInfoToZone(groupPoint,zonePoint)
  local data = {} 
  local group_1_pos = groupPoint
  local group_2_pos = zonePoint
  local distance = ((group_1_pos.x - group_2_pos.x)^2 + (group_1_pos.z - group_2_pos.z)^2)^0.5
  local bearing_vector = {
    x = group_2_pos.x - group_1_pos.x, 
    y = group_2_pos.y - group_1_pos.y, 
    z = group_2_pos.z - group_1_pos.z
    }
  local bearing_rad = math.atan2(bearing_vector.z, bearing_vector.x)
  if bearing_rad < 0 then
      bearing_rad = bearing_rad + (2 * math.pi) 
    end
    local bearing = math.deg(bearing_rad)
    --return math.floor(bearing)..' Degrees for about '..math.floor(UTILS.MetersToNM(distance)).." Nm."
    data.bearing = math.floor(bearing) -- in Degrees
    data.distance = math.floor(UTILS.MetersToNM(distance)) -- in Nm
    return data
end

function Function.TroopMenu(playerGroup)
    local PlayerGroup = playerGroup
    local PlayerGroupName = PlayerGroup:GetName()
  --Setup Menu Option
  local function LoadTroops()
      Function.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
      ctld.loadTransport(PlayerGroupName)
    end
  
  --if huey or mi8 only
    --local TroopInsertionMenu = MENU_GROUP:New( PlayerGroup, "Troop Transport" )
    --local TIInstrustions = MENU_GROUP_COMMAND:New( PlayerGroup, "Instructions", TroopInsertionMenu, ShowInst , PlayerGroup )--instr in CSAR class
    MENU_GROUP_COMMAND:New( PlayerGroup, "Load Infantry Group", nil, LoadTroops , PlayerGroup )
end

function Function.sanitise( str )
    str = str:gsub('%W','')
    return str
end

timer.scheduleFunction(Function.BeaconScheduler, nil, timer.getTime() + 5)