Insertions = Class:derive("Insertions")
Insertions.Settings = {
  markOnComplete = true, --Add map marker for completed task?
  MinNumTroops = 5, --Min # enemy troops at LZ
  MaxNumTroops = 10, --Max # enemy troops at LZ
  MinNumBTR = 0, --Min # enemy BTRs at LZ
  MaxNumBTR = 2, --Max # enemy BTRs at LZ
}

Insertions.Settings.EnemyTroopSpawn = "Insurgent Solider 1-1"
Insertions.Settings.EnemyBTRSpawn = "Insurgent BTR-80 1-1"
Insertions.Settings.EnemyTPzSpawn = "Insurgent Enemy TPz 1-1"
Insertions.Insert_Zones = {
  "Insertion-1",
  "Insertion-2",
  "Insertion-3",
  "Insertion-4",
  "Insertion-5",
  "Insertion-6",
  "Insertion-7",
  "Insertion-8",
  "Insertion-9",
  "Insertion-10",
  "Insertion-11",
  "Insertion-12",
  "Insertion-13",
  "Insertion-14",
  "Insertion-15",
  "Insertion-16",
  "Insertion-17",
  "Insertion-18",
  "Insertion-19",
  "Insertion-20",
} --Zones

Insertions.Insert_Zones_North = {
  "Insertion-North-1",
  
  }

function Insertions:New(playerGroup,InsertZonesTable)
  local PlayerGroup = playerGroup
  local PlayerGroupName = PlayerGroup:GetName()
  
  if Function.GetMooseClientStateData(PlayerGroup,"hasAssignment") == true then
    Function.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
    MESSAGE:New("You have already been assigned a Task. Please review your briefing from F10 Menu. Complete you current task before selecting a new one.",15):ToGroup(PlayerGroup)
  else
    
    if Function.tablelength(InsertZonesTable) >= 1 and Function.tablelength(Settings.RadioFreqs) >= 1 then
      
      --set some local vars
      local EnemyGroupSet = SET_GROUP:New()
      local troopsUnloaded = false
      local missionCompleted = false
      local firstTakeoff = false
      local inHomeAirSpace = false
      local inLZ_Zone = false
      local numofTroops = math.random(Insertions.Settings.MinNumTroops,Insertions.Settings.MaxNumTroops) --number of troops to carry in allied helo
      local numofBTRs = math.random(Insertions.Settings.MinNumBTR,Insertions.Settings.MaxNumBTR)
      local zoneName = Function.randomchoice(InsertZonesTable)
      local wpzoneName = zoneName.."_wp"
      local Zone = ZONE:New(zoneName)
      local WPZone = ZONE:New(wpzoneName)
      local ZoneVec3 = POINT_VEC3:NewFromVec3( Zone:GetVec3() )
      local RadioFreq = Function.GetFreq()
      local flareZone = ZONE_RADIUS:New( "FlareZone", Zone:GetVec2(), 2600 )
      local landingZone = ZONE_RADIUS:New( "LZ", Zone:GetVec2(), 245 )
      local braInfo = Function.GetBRAInfoToZone(PlayerGroup:GetVec3(),Zone:GetVec3()) -- data.bearing, data.distance
      Function.removeTableEntry(InsertZonesTable,zoneName)
      local Task_ID = Function.RandomNumber()
      
      --Set has state to true
      Function.SetMooseClientStateData(PlayerGroup,"hasAssignment", true)
       
      --Set Briefing Menu
      local ranSquad = Function.randomchoice(Settings.Squads)
      local ranRank = Function.randomchoice(Settings.Ranks)
      local ranName = Function.randomchoice(Settings.Names)
      local Briefing = Insertions.GetBriefing(zoneName,ranSquad,ranRank,ranName)
      
      local brief = "Mission #: "..Task_ID.."\n"..
          "Objective: Troop Insertion Operation\n"..
          "Number of Troops : "..numofTroops.."\n"..
          "______________________\n\n".. 
          "Mission : "..Briefing.."\n"..
          "BRA: "..Function.GetBearingToZone(PlayerGroup:GetVec3(),Zone:GetVec3())..'\n'..
          "ADF : "..RadioFreq.." Mhz FM Homing\n"..
          "Troops will auto load momentarily"
           
      Function.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
      MESSAGE:New(brief,35):ToGroup(PlayerGroup)
      
      --CREATE Task in DB
      local lz_lat, lz_long = coord.LOtoLL(Zone:GetPointVec3())
      --LogStats:Insertion_Create_Task(Task_ID,Function.GetMooseClientStateData(PlayerGroup,"ucid"),PlayerGroup:GetTypeName(),brief,numofTroops,lz_lat,lz_long)
       
      local function showBriefing()
        Function.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
        MESSAGE:New(brief,35):ToGroup(PlayerGroup)
      end
      local BriefingMenu = MENU_GROUP:New( PlayerGroup, "Your Assignment" )
      local BriefingMenuCommand = MENU_GROUP_COMMAND:New( PlayerGroup, "Briefing", BriefingMenu, showBriefing , PlayerGroup )
                  
      --Create Beacon
      local beaconID = Function.CreateBeacon(Zone,RadioFreq)
      
      --do enemy units
      local ranNumofOutSideTroops = numofTroops--gen random number of troops math.random(3,5)
        for EnemyTroopCounts = ranNumofOutSideTroops,1,-1
        do
          local grp = Insertions.EnemyTroopSpawnRandomizePosition:SpawnFromVec2( Zone:GetVec2() )  
          EnemyGroupSet:AddGroupsByName(grp)
        end
        
      local ranNumofBTRs = numofBTRs --gen random number of troops math.random(3,5)
        for EnemyBTRCount = ranNumofBTRs,1,-1
        do
          local btrgrp = Insertions.EnemyBTRSpawn:SpawnFromVec2( Zone:GetVec2() )
          EnemyGroupSet:AddGroupsByName(btrgrp)
        end

      --Load Troops onto Transport Unit after x sec
      SCHEDULER:New( nil,
      function()
        Function.PlaySoundToGroup("chirp.ogg",PlayerGroup)
        ctld.preLoadTransport(PlayerGroupName, 6,true)
      end, {},37)
      
      if Zone:GetCoordinate():IsDay() == true then
        --day smoke
        local popSmoke = SCHEDULER:New( nil,
          function()
            if PlayerGroup:IsCompletelyInZone(flareZone) and inLZ_Zone == false then
            inLZ_Zone = true
            Function.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
            PlayerGroup:Message("We hear you near by, popping blue smoke!",15)
              --pop smoke
              Zone:SmokeZone(SMOKECOLOR.Blue,1)
            end
          end, {}, 2,2,0.5,5400)
      else
        --nigh flare
        local popFlare = SCHEDULER:New( nil,
          function()
            if PlayerGroup:IsCompletelyInZone(flareZone) and inLZ_Zone == false then
            inLZ_Zone = true
            Function.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
            PlayerGroup:Message("We hear you near by, popping yellow flares!",15)
              --pop flare
            SCHEDULER:New( nil,
              function()
                Zone:FlareZone(FLARECOLOR.Yellow,1)
              end, {},2,4,0,180)
            end
          end, {}, 2,2,0.5,5400)
      end
      
       
      
      
      --EVENTS
      --Takeoff
      PlayerGroup:HandleEvent(EVENTS.Takeoff)
      function PlayerGroup:OnEventTakeoff(EventData)
     
      
        --first takeoff
        if firstTakeoff == false then
          firstTakeoff = true
          SCHEDULER:New( nil,
            function()
              Function.PlaySoundToGroup("chirp.ogg",PlayerGroup)
              MESSAGE:New(PlayerGroup:GetPlayerName().." For your target, go bearing "..braInfo.bearing.." Degrees. ",15, "HQ"):ToGroup(PlayerGroup)
              
            end, {},math.random(20,40))
            
            
        end

        
      end--end EVENTS.Takeoff
      
      --Landing
      PlayerGroup:HandleEvent(EVENTS.Land)
        function PlayerGroup:OnEventLand(EventData)
          --check if landing in zone to drop off troops
          if PlayerGroup:IsCompletelyInZone(landingZone) and troopsUnloaded == false then 
             SCHEDULER:New( nil,
              function()
                  --unload troops
                 troopsUnloaded = true
                 local grpname = ctld.unloadTransport(PlayerGroupName)
                 SCHEDULER:New( nil,
                    function()
                      Function.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
                      MESSAGE:New("Troops out! Go! Go! Go!",5, "Crew Chief"):ToGroup(PlayerGroup)
                      LogStats.UpdateTransportJsonFile(LogStats.GetMooseClientStateData(PlayerGroup,'ucid'),nil,1,nil,numofTroops)
                    end, {},5)

                 local grp = GROUP:FindByName(grpname)
                 
                 Function.SetMooseClientStateData(PlayerGroup,"hasAssignment", false)
                 
                 Function.StopBeacon(beaconID,RadioFreq)
                 --popFlare:Stop()
                 SCHEDULER:New( nil,
                    function()
                      --MESSAGE:New("Troop moving to WP Zone",3):ToAll()
                      local controller = grp:_GetController()
                      controller:setOption(AI.Option.Ground.id.ROE,0)
                      local controller_task = {
                                id = 'ComboTask',
                                params = {
                                  tasks = grp:TaskRouteToVec2(WPZone:GetVec2())
                                  }
                                }
                      controller:setTask(controller_task)
                      
                      SCHEDULER:New( nil,
                          function()
                            --SpawnEnemyTroopsAtWP(math.random(4,6))
                            --Insertions.SpawnEnemyTroopsAtWP(numofTroops)
                            local ranNumofTroops = numofTroops --gen random number of troops math.random(3,5)
                              for EnemyTroopCount = ranNumofTroops,1,-1
                              do
                                local group = Insertions.EnemyTroopSpawn:SpawnInZone(WPZone,true)
                                EnemyGroupSet:AddGroupsByName(group)
                              end
                          end, {},1)
                        
                        --remove units after 10 min
                        SCHEDULER:New( nil,
                          function()
                            --MESSAGE:New("Destroy Group",5):ToAll()
                            Function.DestroyGroupSet(EnemyGroupSet)
                            Function.DestroyGroup(grp)
                          end, {},600)                  
                      
                    end, {},5)
                 
                 
                 
              end, {}, 3)
          end --end if
          
          --If Landing in allied Zone and troop are unloaded 
          if Function.CheckIfInSafeZone(PlayerGroup,Settings.Allied_LZs) and troopsUnloaded == true and missionCompleted == false then 
            missionCompleted = true
            --Task Successful
            --LogStats:Insertion_Completed_Task(Task_ID,1)
            --LogStats.CreatePlayerDataFile(Function.GetMooseClientStateData(PlayerGroup,"ucid"))
            SCHEDULER:New( nil,
              function()
                Function.PlaySoundTAll("info.ogg")
                MESSAGE:New(PlayerGroup:GetPlayerName().." has successfully inserted "..numofTroops.." troops into battle. Excellent work!",16,"HQ"):ToAll()
                
                Function.SetMooseClientStateData(PlayerGroup,"hasAssignment", false)
                --BriefingMenuCommand:Remove()
                BriefingMenu:Remove()
                
                local missionMarkerText = "Mission ID: "..Task_ID.." - Insertion\n"..
                                        "Pilot: "..PlayerGroup:GetPlayerName().."\n"..
                                        numofTroops.." troops inserted into battle."
                if Insertions.Settings.markOnComplete == true then
                  Function.CreateMarker(Zone,missionMarkerText,true)          
                end
              end, {},5)
            
          end --end if
          
      end--EVENTS.Land
      
      --PlayerLeaveUnit
      PlayerGroup:HandleEvent(EVENTS.PlayerLeaveUnit)
      function PlayerGroup:OnEventPlayerLeaveUnit(EventData)
        Function.SetMooseClientStateData(PlayerGroup,"hasAssignment", false)
        if missionCompleted == false then
          Function.StopBeacon(beaconID,RadioFreq)
          Function.DestroyGroupSet(EnemyGroupSet)
          BriefingMenu:Remove()
          --LogStats:Insertion_Completed_Task(Task_ID,0)
          --LogStats.CreatePlayerDataFile(Function.GetMooseClientStateData(PlayerGroup,"ucid"))
        end
        
      end--end EVENTS.PlayerLeaveUnit
      
      --Player DEAD
      PlayerGroup:HandleEvent(EVENTS.Dead)
      function PlayerGroup:OnEventDead(EventData)
         Function.SetMooseClientStateData(PlayerGroup,"hasAssignment", false)
         if missionCompleted == false then
          Function.StopBeacon(beaconID,RadioFreq)
          Function.DestroyGroupSet(EnemyGroupSet)
          BriefingMenu:Remove()
          --LogStats:Insertion_Completed_Task(Task_ID,0)
          --LogStats.CreatePlayerDataFile(Function.GetMooseClientStateData(PlayerGroup,"ucid"))
        end
        
      end--end EVENTS.DEAD
      
      --Pilot Crash
      PlayerGroup:HandleEvent(EVENTS.Crash)
      function PlayerGroup:OnEventCrash(EventData)
        Function.SetMooseClientStateData(PlayerGroup,"hasAssignment", false)
        if missionCompleted == false then
          Function.StopBeacon(beaconID,RadioFreq)
          Function.DestroyGroupSet(EnemyGroupSet)
          BriefingMenu:Remove()
          --LogStats:Insertion_Completed_Task(Task_ID,0)
          --LogStats.CreatePlayerDataFile(Function.GetMooseClientStateData(PlayerGroup,"ucid"))
        end
      end
      

    else
      --no avalible zones or radio freqs
      Function.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
      MESSAGE:New("Currently no Troop Insertion Assingments at this time, please try back later.",10):ToGroup(PlayerGroup)
    end
    
  end
  
end

function Insertions:Menu(playerGroup)
  local PlayerGroup = playerGroup
  local PlayerGroupName = PlayerGroup:GetName()
  --Setup Menu Option
  local function ShowInst()
      local inst = "++ Troop Insertion Instructions ++"
      Function.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
      MESSAGE:New(inst,10):ToGroup(PlayerGroup)
    end
  local function GetAssignmentNorth()
    Function.PlaySoundToGroup("beep1.ogg",PlayerGroup)
    MESSAGE:New(">> Incoming Troop Insertion Assigment for "..PlayerGroupName,5):ToGroup(PlayerGroup)
    SCHEDULER:New( nil,
      function()
        Function.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
        Insertions:New(PlayerGroup,Insertions.Insert_Zones_North)
      end, {},6)
    
  end
  
  local function GetAssignment()
    Function.PlaySoundToGroup("beep1.ogg",PlayerGroup)
    MESSAGE:New(">> Incoming Troop Insertion Assigment for "..PlayerGroupName,5):ToGroup(PlayerGroup)
    SCHEDULER:New( nil,
      function()
        Function.PlaySoundToGroup("radioscratch.ogg",PlayerGroup)
        Insertions:New(PlayerGroup,Insertions.Insert_Zones)
      end, {},6)
    
  end
  
  if PlayerGroup:GetTypeName() == "UH-1H" or PlayerGroup:GetTypeName() == "Mi-8MT" then
    if Function.CheckIfInZone(PlayerGroup,Settings.Allied_North_LZs) == true then
      --north
      local InsertionsMenu = MENU_GROUP:New( PlayerGroup, "Troop Transport" )
      --local TIInstrustions = MENU_GROUP_COMMAND:New( PlayerGroup, "Instructions", InsertionsMenu, ShowInst , PlayerGroup )--instr in CSAR class
      local GetTIAssignment = MENU_GROUP_COMMAND:New( PlayerGroup, "Troop Insertions", InsertionsMenu, GetAssignmentNorth , PlayerGroup )
  
    end
    if Function.CheckIfInZone(PlayerGroup,Settings.Allied_South_LZs) == true then
      --south
      local InsertionsMenu = MENU_GROUP:New( PlayerGroup, "Troop Transport" )
      --local TIInstrustions = MENU_GROUP_COMMAND:New( PlayerGroup, "Instructions", InsertionsMenu, ShowInst , PlayerGroup )--instr in CSAR class
      local GetTIAssignment = MENU_GROUP_COMMAND:New( PlayerGroup, "Troop Insertions", InsertionsMenu, GetAssignment , PlayerGroup )
  
    end
    end
end

Insertions.EnemyTroopSpawn = SPAWN:New(Insertions.Settings.EnemyTroopSpawn)
     --:InitRandomizeZones({Zone})
     :OnSpawnGroup(
      function( SpawnGroup )
        SpawnGroup:HandleEvent(EVENTS.Birth)
        function SpawnGroup:OnEventBirth(EventData)
          
        end
        SpawnGroup:HandleEvent(EVENTS.Dead)
        function SpawnGroup:OnEventDead(EventData)
          
        end
      end
      )
      --:InitLimit(4,4)
      :InitHeading(0,359)
      --:InitRandomizePosition( true , 600, 350 )
      --:SpawnScheduled(0.5,0)

Insertions.EnemyTroopSpawnRandomizePosition = SPAWN:New(Insertions.Settings.EnemyTroopSpawn)
     :OnSpawnGroup(
      function( SpawnGroup )
        SpawnGroup:HandleEvent(EVENTS.Birth)
        function SpawnGroup:OnEventBirth(EventData)
          
        end
        SpawnGroup:HandleEvent(EVENTS.Dead)
        function SpawnGroup:OnEventDead(EventData)
          
        end
      end
      )
      :InitHeading(0,359)
      :InitRandomizePosition( true , 600, 350 )

      
Insertions.EnemyBTRSpawn = SPAWN:New(Insertions.Settings.EnemyBTRSpawn)
     :OnSpawnGroup(
      function( SpawnGroup )
        SpawnGroup:HandleEvent(EVENTS.Birth)
        function SpawnGroup:OnEventBirth(EventData)
          
        end
        SpawnGroup:HandleEvent(EVENTS.Dead)
        function SpawnGroup:OnEventDead(EventData)
          
        end
      end
      )
      :InitHeading(0,359)
      :InitRandomizePosition( true , 1205, 1200 )

function Insertions.GetBriefing(ZoneName,ranSquad,ranRank,ranName)
  local briefing = ""
  
  briefing = ranRank.." "..ranName.." is currently requesting reinforcement troops. Get those troops over to his location at once. You may return to any FARP or allied base you wish."

  return briefing
end